#include "src/qt/mainwindow.h"
#include <QApplication>
#include "main.h"

// TODO: fix qwerty mapping
// TODO: handlers, qui a besoin de qui et quand, pas de redondance ? chemins les + simples ?
// TODO: lock pour la modif, histoire de péter tout le backend sans que l'ihm explose
// TODO: list les features présentes et à venir, disons jusqu'à la v1.0 alpha pour commencer
// TODO MF: intégration/merge avec autre doc, gaffe aux scaling, normalisation générale des coords pour nos fichiers ?
// TODO: stitch de remplissage de formes
// TODO: rotation des selections
// TODO: creation des groupes
// TODO: export des .pes
// TODO: edition des motifs
// TODO: set des motifs des linestitchs avec miniature
// TODO: echelle dans la vue (cm/mm)

// liste des bugs identifiés a corriger
// TODO bug dans OE_interfaceDisplay::selectApply la selection ne clear qu'un seul type (curve ou stitch) quand on selection uniquement des objets de l'autre type
// TODO bug dans les selections avec ajout sur les stitchs

// TODO put back drop functionnality
/*
static void OE_Drop_callback(GLFWwindow* window,  int nbFiles, const char ** files)
{
	OE_root* root = (OE_root*)glfwGetWindowUserPointer(window);
	if ((!root->document)||(nbFiles<=0)) return;

	std::string path(*files);
	size_t dot = path.find_last_of(".");
	if (dot == std::string::npos) return;

	std::string ext  = path.substr(dot, path.size() - dot);
	if (ext == ".oe")
	{
		printf("Importing oe file from %s\n", path.c_str());
		OE_document* tmp_doc = new OE_document;
		delete root->document;
		root->document = tmp_doc;
		root->document->loadFromFile(path);

	}
	if (ext == ".pes")
	{
		printf("Importing pes file from %s\n", path.c_str());
		OE_document* tmp_doc = new OE_document;
		delete root->document;
		root->document = tmp_doc;
		root->document->loadFromPES(path);
	}
	if (ext == ".svg")
	{
		printf("Importing svg file from %s\n", path.c_str());
		OE_document* tmp_doc = OE_svgParser::fromFile(path, "px", 96.0f);
		// Center document around (0,0)
		BoundingBox bb = tmp_doc->getBound();
		for (auto curve : tmp_doc->curves)
		{
			curve->move(vector_2d(0,0)-bb.getCenter());
		}
		// Rescale document if larger than hoop
		bb = tmp_doc->getBound();
		float docW = bb.getMax().x-bb.getMin().x;
		float docH = bb.getMax().y-bb.getMin().y;
		float hoopW = tmp_doc->getHoopSize().x;
		float hoopH = tmp_doc->getHoopSize().y;
		if (docW > hoopW || docH > hoopH)
		{
			float ratio = nanf("");
			if (docW >= docH && docW != 0.0f)
			{
				ratio = hoopW / (docW);
			}
			else if (docW < docH && docH != 0.0f)
			{
				ratio = hoopH / (docH);
			}
			if (!std::isnan(ratio))
			{
				for (auto curve : tmp_doc->curves)
				{
					curve->scale(vector_2d(ratio, ratio), bb.getCenter());
				}
			}
		}
		if (tmp_doc != NULL) {
			delete root->document;
			root->document = tmp_doc;
		}else{
			printf("Could not open SVG image.\n");
		}
	}

	if (root->controller)
	{
		root->controller->setDocument(root->document);
		root->controller->initNewDocument();
	}

	if (root->display)
	{
		root->display->setDocument(root->document);
		root->display->showAll();
	}
}
*/

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	MainWindow w;

	OE_root root;
	root.document = new OE_document();
	root.document->loadFromPES("C:\\Users\\raoul\\Downloads\\openEmbroidery_software\\motifs\\ms0902.PES");
	root.interfaceDisplay = w.getItfDisplay();//new OE_interfaceDisplay();
	root.interfaceDisplay->setDocument(root.document);
	root.display = root.interfaceDisplay;
	root.controller = new OE_controller(root.display, root.document);
	root.controller->initNewDocument();
	root.display->setController(root.controller);

	/*root.display->resize(800, 600);
	root.display->draw();
	root.display->showAll();*/

	//w.addTab(&doc, "Robert");
	w.show();

	return a.exec();
}
